Attribute VB_Name = "Mathcrap"
Public Const EncUpperSetStr$ = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789ABCDEFGHIJKLM"
Public Const EncLowerSetStr$ = "abcdefghijklmnopqrstuvwxyz0123456789abcdefghijklm"
Public Const DecUpperSetStr$ = "MLKJIHGFEDCBA9876543210ZYXWVUTSRQPONMLKJIHGFEDCBA"
Public Const DecLowerSetStr$ = "mlkjihgfedcba987654321zyxwvutsrqponmlkjihgfedcba"
Public Enum TimeFormatType
    DaysHoursMinutesSecondsMilliseconds = 0
    DaysHoursMinutesSeconds = 1
    DHMSMColonSeparated = 2
    DaysHoursMinutes = 3
End Enum
Public Function HexToStr(ByVal Hex1 As String) As String
    Dim strTemp As String, strReturn As String, i As Long
    Hex1 = Replace(Hex1, " ", "")
    If Len(Hex1) Mod 2 <> 0 Then Exit Function

    For i = 1 To Len(Hex1) Step 2
    strReturn = strReturn & Chr(Val("&H" & Mid(Hex1, i, 2)))
    Next i
    HexToStr = strReturn
End Function
Public Function StrToHex(ByVal String1 As String) As String
    Dim strTemp As String, strReturn As String, i As Long
    
    For i = 1 To Len(String1)
        strTemp = Hex(Asc(Mid(String1, i, 1)))
    If Len(strTemp) = 1 Then strTemp = "0" & strTemp
    
    strReturn = strReturn & " " & strTemp
    
    Next i
        StrToHex = strReturn
    
End Function
Public Sub NullTruncString(ByRef text As String)
On Error Resume Next
    Dim i As Integer
    
    i = InStr(text, Chr(0))
    If i = 0 Then Exit Sub
    
    text = Left(text, i - 1)
End Sub


Function IsUpperCase(ByVal StrInString As String) As Boolean

    If StrComp(Trim(StrInString), "") = 0 Then
        IsUpperCase = False
        Exit Function
    End If
    
    If StrComp(StrInString, UCase(StrInString)) = 0 Then
        IsUpperCase = True
    Else
        IsUpperCase = False
    End If

End Function
Function Rot13(ByVal StrInString As String) As String

    Dim LngPointer As Long
    Dim StrNewChar As String
    LngPointer = 1
    
    While LngPointer <> Len(StrInString)
        DoEvents
        Select Case Asc(Mid(StrInString, LngPointer, 1))
            Case 65, 97
                StrNewChar = "N"
            Case 66, 98
                StrNewChar = "O"
            Case 67, 99
                StrNewChar = "P"
            Case 68, 100
                StrNewChar = "Q"
            Case 69, 101
                StrNewChar = "R"
            Case 70, 102
                StrNewChar = "S"
            Case 71, 103
                StrNewChar = "T"
            Case 72, 104
                StrNewChar = "U"
            Case 73, 105
                StrNewChar = "V"
            Case 74, 106
                StrNewChar = "W"
            Case 75, 107
                StrNewChar = "X"
            Case 76, 108
                StrNewChar = "Y"
            Case 77, 109
                StrNewChar = "Z"
            Case 78, 110
                StrNewChar = "A"
            Case 79, 111
                StrNewChar = "B"
            Case 80, 112
                StrNewChar = "C"
            Case 81, 113
                StrNewChar = "D"
            Case 82, 114
                StrNewChar = "E"
            Case 83, 115
                StrNewChar = "F"
            Case 84, 116
                StrNewChar = "G"
            Case 85, 117
                StrNewChar = "H"
            Case 86, 118
                StrNewChar = "I"
            Case 87, 119
                StrNewChar = "J"
            Case 88, 120
                StrNewChar = "K"
            Case 89, 121
                StrNewChar = "L"
            Case 90, 122
                StrNewChar = "M"
            Case Else
                StrNewChar = Mid(StrInString, LngPointer, 1)
        End Select
        
        If IsUpperCase(Mid(StrInString, LngPointer, 1)) Then
            Mid(StrInString, LngPointer, 1) = StrNewChar
        Else
            Mid(StrInString, LngPointer, 1) = LCase(StrNewChar)
        End If
        
        LngPointer = LngPointer + 1
    Wend
    
    Rot13 = StrInString

End Function

Public Function FormatCount(Count As Long, Optional FormatType As TimeFormatType = 0) As String
    Dim Days As Long, Hours As Long, Minutes As Long, Seconds As Long, Miliseconds As Long
    
    Miliseconds = Count Mod 1000
    Count = Count \ 1000
    Days = Count \ (24& * 3600&)
    If Days > 0 Then Count = Count - (24& * 3600& * Days)
    Hours = Count \ 3600&
    If Hours > 0 Then Count = Count - (3600& * Hours)
    Minutes = Count \ 60
    Seconds = Count Mod 60


    Select Case FormatType
            Case 0


        FormatCount = Days & " days, " & Hours & " hours, " & _
            Minutes & " minutes, " & Seconds & " seconds, " & Miliseconds & _
            " milliseconds"
            Case 1


            FormatCount = Days & " days, " & Hours & " hours, " & _
                Minutes & " minutes, " & Seconds & " seconds"
            Case 2


                FormatCount = Days & ":" & Hours & ":" & _
                    Minutes & ":" & Seconds & ":" & Miliseconds
            
            Case 3
            Dim buffer As String
            buffer = Minutes & " minutes"
            If Hours >= 1 Then
            buffer = Hours & " hours, " & buffer
            End If
            If Days >= 1 Then
            buffer = Days & " days, " & buffer
            End If
            FormatCount = buffer 'Days & " days, " & Hours & " hours, " & _
                'Minutes & " minutes"
    End Select
End Function

