VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "bnetchat"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private Const ID_EMOTE = &H17
Private Const ID_WHISPTO = &HA
Private Const ID_WHISPFROM = &H4
Private Const ID_TALK = &H5
Private Const ID_USER = &H1
Private Const ID_JOIN = &H2
Private Const ID_LEAVE = &H3
Private Const ID_FLAGS = &H9
Private Const ID_CHAN = &H7
Private Const ID_ERROR = &H13
Private Const ID_INFO = &H12
Private Const ID_BROADCAST = &H6
Private Const pidSEXP = 1
Private Const pidSTAR = 4
Private Const pidD2DV = 6
Private Const pidD2XP = 7
Private Const pidW2BN = 3
Private Const pidJSTR = 5
Private Const pidSSHR = 2
Private Const pidWAR3 = 15
Private Const pidDSHR = 9
Private Const pidCHAT = 10
Private Const pidELSE = 11
Private Const pidDRTL = 8
Private Const pidBLIZZ = 14
Private Const pidOP = 12
Private Const pidSQU = 13
Public Event OnUser(ByVal Username As String, ByVal flags As Long, ByVal Message As String, ByVal Ping As Long)
Public Event OnJoin(ByVal Username As String, ByVal flags As Long, ByVal Message As String, ByVal Ping As Long)
Public Event OnLeave(ByVal Username As String, ByVal flags As Long)
Public Event OnWhisperFrom(ByVal Username As String, ByVal flags As Long, ByVal Message As String)
Public Event OnTalk(ByVal Username As String, ByVal flags As Long, ByVal Message As String, ByVal Ping As Long)
Public Event OnChannel(ByVal ChannelName As String)
Public Event OnFlags(ByVal Username As String, ByVal flags As Long, ByVal Message As String, ByVal Ping As Long)
Public Event OnWhisperTo(ByVal Username As String, ByVal flags As Long, ByVal Message As String, ByVal Ping As Long)
Public Event OnInfo(ByVal Message As String)
Public Event OnError(ByVal Message As String)
Public Event OnEmote(ByVal Username As String, ByVal flags As Long, ByVal Message As String)
Public Event OnUnknown(ByVal UnknownString As String)
Public Sub DispatchMessage(ByVal databuf As String)
Dim EID As Long, Ping As Long, Username As String, Message As String
    EID = MakeLong(Mid$(databuf, 5, 4))
    flags = MakeLong(Mid$(databuf, 9, 4))
    Ping = MakeLong(Mid$(databuf, 13, 4))
Username = KillNull(Mid$(databuf, 29))
Message = KillNull(Mid$(databuf, Len(Username) + 30))
Select Case EID
Case ID_TALK
RaiseEvent OnTalk(Username, flags, Message, Ping)
Exit Sub
Case ID_EMOTE
RaiseEvent OnEmote(Username, flags, Message)
Exit Sub
Case ID_CHAN
RaiseEvent OnChannel(Message)
Exit Sub
Case ID_USER
RaiseEvent OnUser(Username, flags, Message, Ping)
Exit Sub
Case ID_JOIN
RaiseEvent OnJoin(Username, flags, Message, Ping)
Exit Sub
Case ID_LEAVE
RaiseEvent OnLeave(Username, flags)
Exit Sub
Case ID_WHISPTO
RaiseEvent OnWhisperTo(Username, flags, Message, Ping)
Exit Sub
Case ID_WHISPFROM
RaiseEvent OnWhisperFrom(Username, flags, Message)
Exit Sub
Case ID_INFO
RaiseEvent OnInfo(Message)
Exit Sub
Case ID_FLAGS
RaiseEvent OnFlags(Username, flags, Message, Ping)
Exit Sub
Case ID_BROADCAST
RaiseEvent OnInfo(Message)
Exit Sub
Case ID_ERROR
RaiseEvent OnError(Message)
Exit Sub
Case Else
RaiseEvent OnUnknown(Message)
Exit Sub
End Select
End Sub
Function MakeLong(x As String) As Long
    If Len(x) < 4 Then
        Exit Function
    End If
    CopyMemory MakeLong, ByVal x, 4
End Function
Public Function GetIconCode(ByVal statstring As String, ByVal flags As Long) As Integer
product = Mid(statstring, 1, 4)

    If (BNFLAGS_BLIZZ And flags) = BNFLAGS_BLIZZ Then
        GetIconCode = pidBLIZZ
            Exit Function
       ElseIf (BNFLAGS_OP And flags) = BNFLAGS_OP Then
        GetIconCode = pidOP
            Exit Function
        ElseIf (BNFLAGS_SQUELCH And flags) = BNFLAGS_SQUELCH Then
         GetIconCode = pidSQU
            Exit Function
            End If
    
   Select Case product
        Case "PXES": GetIconCode = pidSEXP
        Case "RATS": GetIconCode = pidSTAR
        Case "RTSJ": GetIconCode = pidJSTR
        Case "RHSS": GetIconCode = pidSSHR
        Case "NB2W": GetIconCode = pidW2BN
        Case "VD2D": GetIconCode = pidD2DV
        Case "PX2D": GetIconCode = pidD2XP
        Case "LTRD": GetIconCode = pidDRTL
        Case "RHSD": GetIconCode = pidDSHR
        Case "TAHC": GetIconCode = pidCHAT
        Case "3RAW": GetIconCode = pidWAR3
        Case Else: GetIconCode = pidELSE
    End Select

    
End Function
