VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "botnetclass"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private Const ID_HUBLOGIN = &H1
Private Const ID_UPDATE = &H2
Private Const ID_INFO = &H6
Private Const ID_BOTDISC = &H7
Private Const ID_VERSION = &HA
Private Const ID_CHAT = &HB
Private Const ID_ACCOUNT = &HD
Public Enum chattype
    chat = &H1
    chatemote = &H2
    data = &H3
    dataemote = &H4
    whisper = &H5
    whisperemote = &H6
End Enum
Public Event HubLogin(ByVal Pass As Boolean)
Public Event BotUpdate(ByVal Pass As Boolean)
Public Event BotInfo(ByVal botid As Long, Server As String, Channel As String, Name As String)
Public Event BotDisc(ByVal botid As Long)
Public Event ServerVersion(ByVal ServerVersion As Long)
Public Event BotChat(ByVal botid As Long, ByVal message As String, ByVal datachat As chattype)
Public Sub DispatchMessage(ByVal databuf As String)
Dim PacketID As Long, Username As String, message As String, action As Long, botid As Long _
, splt() As String
PacketID = Asc(Mid(databuf, 2, 1))
Select Case PacketID
Case ID_HUBLOGIN
action = GetDWORD(Mid(databuf, 3, 4))
If action = &H0 Then
RaiseEvent HubLogin(False)
Else
RaiseEvent HubLogin(True)
End If
Case ID_UPDATE
action = GetDWORD(Mid(databuf, 3, 4))
If action = &H0 Then
RaiseEvent BotUpdate(False)
Else
RaiseEvent BotUpdate(True)
End If
Case ID_INFO
botid = GetDWORD(Mid(databuf, 5, 4))
splt() = Split(Mid(databuf, 9, Len(databuf) - 8), Chr(0), 3)
message = makeserver(splt(2))
RaiseEvent BotInfo(botid, message, splt(1), splt(0))
Case ID_VERSION
action = GetDWORD(Mid(databuf, 3, 4))
RaiseEvent ServerVersion(action)
Case ID_BOTDISC
botid = GetDWORD(Mid(databuf, 3, 4))
RaiseEvent BotDisc(botid)
Case ID_CHAT
Dim command As Long
command = GetDWORD(Mid(databuf, 5, 4))
action = GetDWORD(Mid(databuf, 9, 4))
botid = GetDWORD(Mid(databuf, 13, 4))
End Select

End Sub
Public Function makeserver(data As String) As String
makeserver = CLng("&H" & BNb.ToHex(Mid(data, 1, 1))) & "." & CLng("&H" & BNb.ToHex(Mid(data, 2, 1))) & "." & CLng("&H" & BNb.ToHex(Mid(data, 3, 1))) & "." & CLng("&H" & BNb.ToHex(Mid(data, 4, 1)))
End Function
