Attribute VB_Name = "parseingf"
Private Const ID_EMOTE = &H17
Private Const ID_WHISPTO = &HA
Private Const ID_WHISPFROM = &H4
Private Const ID_TALK = &H5
Private Const ID_USER = &H1
Private Const ID_JOIN = &H2
Private Const ID_LEAVE = &H3
Private Const ID_FLAGS = &H9
Private Const ID_CHAN = &H7
Private Const ID_ERROR = &H13
Private Const ID_INFO = &H12
Private Const ID_BROADCAST = &H6
Private Const ID_DNE = &HE
Private Const ID_RESTRICTED = &HF
Private Const ID_FULL = &HD
Private Const CHNFLAG_PUB = &H1
Private Const CHNFLAG_MOD = &H2
Private Const CHNFLAG_STS = &H4
Private Const CHNFLAG_VOID = &H8
Private Const CHNFLAG_ADMIN = &H10
Private Const CHNFLAG_PROD = &H20
Private Const CHNFLAG_ALL = &H1000
Public Const BNFLAGS_BLIZZ = &H1
Public Const BNFLAGS_OP = &H2
Public Const BNFLAGS_SPKR = &H4
Public Const BNFLAGS_SYSOP = &H8
Public Const BNFLAGS_PLUG = &H10
Public Const BNFLAGS_SQUELCH = &H20
Public Const BNFLAGS_GLASSES = &H40
Public Sub Parse0f(strData As String)
Dim usrFlags&, Ping&, usrName$, usrText$



If Len(strData) < 4 Then Exit Sub
    

        Select Case Asc(Mid(strData, 5, 1))
            Case ID_WHISPFROM: Event_RecvWhisper usrName, usrFlags, usrText
            Case ID_TALK: Event_Talk usrName, usrFlags, usrText, Ping
            Case ID_EMOTE: Event_Emote usrName, usrFlags, usrText
            Case ID_JOIN: Event_Join usrName, usrFlags, usrText, Ping
            Case ID_USER: Event_User usrName, usrFlags, usrText, Ping
            Case ID_FLAGS: Event_Flags usrName, usrFlags, usrText, Ping
            Case ID_ERROR: Event_Error usrText
            Case ID_DNE: Event_Error usrText
            Case ID_RESTRICTED: Event_Error usrText
            Case ID_FULL: Event_Error usrText
            Case ID_WHISPTO: Event_sendWhisper usrName, usrFlags, usrText, Ping
            Case ID_CHAN: Event_Channel usrText, usrFlags, Ping
            Case ID_BROADCAST: Event_Info usrText
            Case ID_INFO: Event_Info usrText
            Case ID_LEAVE: Event_Leave usrName, usrFlags
            Case Else: Event_Unknown strData
        End Select
End Sub

Public Sub Event_Emote(user As String, Flags As Long, Text As String)
If InStr(LCase(Text), "vlbbot") Or InStr(LCase(Text), "dark`bot") Or InStr(LCase(Text), "idle:") Or InStr(LCase(Text), "ultima") Or InStr(LCase(Text), "binarychat") Or InStr(LCase(Text), "annoying don't you") Or InStr(LCase(Text), "chewbacca bot") Or InStr(LCase(Text), "stygian") Or InStr(LCase(Text), "bobo") Or InStr(LCase(Text), "dpbot") Or InStr(LCase(Text), "ultrabot") Or InStr(LCase(Text), "anti") Or InStr(LCase(Text), "idle") Then: Exit Sub
TimeStampC
AddC yellow, "* " & user & " " & Text & " *" & vbCrLf
End Sub
Private Sub Event_Unknown(strText As String)
TimeStampC
AddC lblue, strText & vbCrLf
End Sub
Private Sub Event_User(strUser As String, strFlag As Long, strstatstring, Ping)
On Error Resume Next
Dim strss As String
StatStringParsing.ParseStatString strstatstring, strss
Functions.addlu strUser, strFlag, strss, Ping, strstatstring
TimeStampJ
Addj grey, strUser & ":" & strFlag & ":" & Ping & " is here on " & strss & vbCrLf
Form1.lchan.Caption = cchannel & " (" & Form1.lstusers.ListItems.Count & ")"
End Sub
Private Sub Event_Join(strUser As String, strFlag As Long, strstatstring, Ping)
Dim strss As String
StatStringParsing.ParseStatString strstatstring, strss
addlu strUser, strFlag, strss, Ping, strstatstring
TimeStampJ
Addj dgreen, strUser & ":" & strFlag & ":" & Ping & " joined the channel using " & strss & vbCrLf
Form1.lchan.Caption = cchannel & " (" & Form1.lstusers.ListItems.Count & ")"
End Sub
Private Sub Event_Leave(strUser As String, strFlag)
On Error Resume Next
remlu strUser
TimeStampJ
Addj dgreen, strUser & " has left the channel" & vbCrLf
Form1.lchan.Caption = cchannel & " (" & Form1.lstusers.ListItems.Count & ")"
End Sub
Private Sub Event_RecvWhisper(strUser As String, strFlag As Long, strText As String)
If Left(strText, 12) = "Your friend " Then: Exit Sub
TimeStampW
AddW green, "From " & strUser & ": ", white, strText & vbCrLf
TimeStampC
AddC green, "From " & strUser & ": ", grey, strText & vbCrLf
End Sub
Private Sub Event_Talk(strUser As String, strFlag, strText As String, Ping)
TimeStampC
AddC green, strUser & ": ", white, strText & vbCrLf
End Sub
Private Sub Event_Broadcast(strText As String)
TimeStampC
AddC yellow, "Broadcast Message: " & strText & vbCrLf
End Sub

Private Sub Event_Channel(strText As String, strFlag As Long, Ping)
TimeStampC
AddC lblue, "You have joined channel " & strText & " " & "Flags:" & strFlag & vbCrLf
Form1.lstusers.ListItems.Clear
cchannel = strText
TimeStampJ
Addj white, "Joined channel " & strText
End Sub

Private Sub Event_Flags(strUser As String, strFlag As Long, statstring As String, Ping As Long)
Dim strss As String
StatStringParsing.ParseStatString strstatstring, strss
If (strFlag And BNFLAGS_OP) Then
remlu strUser
addlu strUser, strFlag, strss, Ping, statstring
End If
End Sub

Private Sub Event_sendWhisper(strUser As String, strFlag, strText As String, Ping)
TimeStampW
AddW green, "To " & strUser & ": ", white, strText & vbCrLf
TimeStampC
AddC green, "To " & strUser & ": ", grey, strText & vbCrLf
End Sub

Private Sub Event_Info(strText As String)

    TimeStampC
    AddC yellow, "Broadcast: " & strText & vbCrLf

   
End Sub

Private Sub Event_Error(strText As String)
TimeStampC
AddC red, strText & vbCrLf

End Sub
