Attribute VB_Name = "Functions"
Public Const NIM_ADD = &H0
Public Const NIM_MODIFY = &H1
Public Const NIM_DELETE = &H2
Public Const NIF_MESSAGE = &H1
Public Const NIF_ICON = &H2
Public Const NIF_TIP = &H4
Public Const WM_MOUSEMOVE = &H200
Public Const WM_LBUTTONDOWN = &H201
Public Const WM_LBUTTONUP = &H202
Public Const WM_LBUTTONDBLCLK = &H203
Public Const WM_RBUTTONDOWN = &H204
Public Const WM_RBUTTONUP = &H205
Public Const WM_RBUTTONDBLCLK = &H206
Public Const HWND_TOPMOST = -1
Public nid As NOTIFYICONDATA
Public Type NOTIFYICONDATA
cbSize As Long
hwnd As Long
uId As Long
Uflags As Long
uCallBackMessage As Long
hIcon As Long
szTip As String * 64
End Type
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Public Declare Function Shell_NotifyIcon Lib "shell32" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, pnid As NOTIFYICONDATA) As Boolean
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Function FileExist(fName As String) As Boolean
    On Local Error Resume Next
   FileExist = (Dir(fName) <> "")
End Function
Public Function GetHexValue(ByVal v As Long) As String

    v = v And &HF
    
    If v < 10 Then
    
        GetHexValue = Chr$(v + &H30)
        
    Else
    
        GetHexValue = Chr$(v + &H37)
        
    End If
    
End Function

Public Function GetNumValue(ByVal c As String) As Long

    c = UCase(c)
    
    If IsNumeric(c) Then
    
        GetNumValue = Asc(c) - &H30
        
    Else
    
        GetNumValue = Asc(c) - &H37
        
    End If
    
End Function


Public Function DecodeD2Key(ByVal key As String) As String
    Dim r As Double, n As Double, n2 As Double, v As Double, _
    v2 As Double, keyvalue As Double, c1 As Byte, c2 As Byte, _
    c As Byte, bValid As Boolean, i As Integer, aryKey(0 To 15) As String, _
    codevalues As String
    
    codevalues = "246789BCDEFGHJKMNPRTVWXZ"
    r = 1
    keyvalue = 0
    
    For i = 1 To 16
    
        aryKey(i - 1) = Mid$(key, i, 1)
        
    Next i
    
    For i = 0 To 15 Step 2
        c1 = InStr(1, codevalues, aryKey(i)) - 1
        If c1 = -1 Then c1 = &HFF
        n = c1 * 3
        c2 = InStr(1, codevalues, aryKey(i + 1)) - 1
        If c2 = -1 Then c2 = &HFF
        n = c2 + n * 8
        
        If n >= &H100 Then
        
            n = n - &H100
            keyvalue = keyvalue Or r
            
        End If
        
        n2 = n
        n2 = RShift(n2, 4)
        aryKey(i) = GetHexValue(n2)
        aryKey(i + 1) = GetHexValue(n)
        r = LShift(r, 1)
        
Cont:

    Next i
    
    v = 3
    
    For i = 0 To 15
    
        c = GetNumValue(aryKey(i))
        n = Val(c)
        n2 = v * 2
        n = n Xor n2
        v = v + n
        
    Next i
    
    v = v And &HFF
    
    For i = 15 To 0 Step -1
    
        c = Asc(aryKey(i))
        
        If i > 8 Then
        
            n = i - 9
            
        Else
        
            n = &HF - (8 - i)
            
        End If
        
        n = n And &HF
        c2 = Asc(aryKey(n))
        aryKey(i) = Chr$(c2)
        aryKey(n) = Chr$(c)
        
    Next i
    
    v2 = &H13AC9741
    
    For i = 15 To 0 Step -1
    
        c = Asc(UCase(aryKey(i)))
        aryKey(i) = Chr$(c)
        
        If Val(c) <= Asc("7") Then
        
            v = v2
            c2 = v And &HF
            c2 = c2 And 7
            c2 = c2 Xor c
            v = RShift(v, 3)
            aryKey(i) = Chr$(c2)
            v2 = v
            
        ElseIf Val(c) < Asc("A") Then
        
            c2 = CByte(i)
            c2 = c2 And 1
            c2 = c2 Xor c
            aryKey(i) = Chr$(c2)
            
        End If
        
    Next i
    
    DecodeD2Key = Join(aryKey, "")
    
    Erase aryKey()
    
End Function

Public Function DecodeStarcraftKey(ByVal sKey As String) As String

    Dim r As Double, n As Double, n2 As Double, v As Double, _
    v2 As Double, keyvalue As Double, c1 As Byte, c2 As Byte, c As Byte, _
    bValid As Boolean, i As Integer, aryKey(0 To 12) As String
    
    For i = 1 To 13
    
        aryKey(i - 1) = Mid$(sKey, i, 1)
        
    Next i
    
    v = 3
    
    For i = 0 To 11
    
        c = aryKey(i)
        n = Val(c)
        n2 = v * 2
        n = n Xor n2
        v = v + n
        
    Next i
    
    v = v Mod 10
    
    If Hex(v) = aryKey(12) Then
    
        bValid = True
        
    End If
    
    v = 194
    
    For i = 11 To 0 Step -1
    
        If v < 7 Then GoTo continue
        c = aryKey(i)
        n = CInt(v / 12)
        n2 = v Mod 12
        v = v - 17
        c2 = aryKey(n2)
        aryKey(i) = c2
        aryKey(n2) = c
        
    Next i
    
continue:

    v2 = &H13AC9741
    
    For i = 11 To 0 Step -1
    
        c = UCase$(aryKey(i))
        aryKey(i) = c
        
        If Asc(c) <= Asc("7") Then
        
            v = v2
            c2 = v And &HFF
            c2 = c2 And 7
            c2 = c2 Xor c
            v = RShift(CLng(v), 3)
            aryKey(i) = c2
            v2 = v
            
        ElseIf Asc(c) < 65 Then
        
            c2 = CByte(i)
            c2 = c2 And 1
            c2 = c2 Xor c
            aryKey(i) = c2
            
        End If
        
    Next i
    
    DecodeStarcraftKey = Join(aryKey, "")
    
    Erase aryKey()
    
End Function
Public Function KillNull(ByVal text As String) As String
    Dim i As Integer
    i = InStr(1, text, Chr(0))
    If i = 0 Then
        KillNull = text
        Exit Function
    End If
    KillNull = Left(text, i - 1)
End Function
Public Function LShift(ByVal pnValue As Long, ByVal pnShift As Long) As Double
' Equivilant to C's Bitwise << ope
' rator
    LShift = CDbl(pnValue * (2 ^ pnShift))
End Function

Public Function RShift(ByVal pnValue As Long, ByVal pnShift As Long) As Double
' Equivilant to C's Bitwise >> ope
' rator
    RShift = CDbl(pnValue \ (2 ^ pnShift))
End Function

Public Function CStrToLng(ByVal String1$) As Long

    Dim sTemp$
        
    For i = Len(String1) To 1 Step -1
        sTemp = sTemp & Right$("0" & Hex(Asc(Mid$(String1, i, 1))), 2)
    Next i

    CStrToLng = (Val("&H" & sTemp))
    
End Function

Public Function StripKey(Expression$, tString$)
    Dim Keys() As String
        StripKey = Expression
        For tLoop = 0 To Len(tString)
        StripKey = Replace(StripKey, Mid$(tString$, tLoop + 1, 1), Empty)
    Next
End Function
Public Function send(text As String)
If Chatf.ws.State = sckConnected And Connected = True Then
If chatlock <> "" Then
text = chatlock & " " & text
End If
If InStr(text, vbCrLf) Then
Dim splt() As String, x As Long
splt() = Split(text, vbCrLf)
For x = 0 To UBound(splt)
text = splt(x)
If InStr(text, "%") Then
text = Replace(text, "%red", "C1")
text = Replace(text, "%green", "C2")
text = Replace(text, "%blue", "C3")
text = Replace(text, "%gold", "C4")
text = Replace(text, "%gray", "C5")
text = Replace(text, "%black", "C6")
text = Replace(text, "%lgold", "C7")
text = Replace(text, "%orange", "C8")
text = Replace(text, "%yellow", "C9")
End If
If Left(text, 1) = "/" Then
Else

    AddC lblue, myname & ": ", white, text
End If

pbuffer.InsertNTString text
pbuffer.SendPacket &HE
Next
Else
If InStr(text, "%") Then
text = Replace(text, "%red", "C1")
text = Replace(text, "%green", "C2")
text = Replace(text, "%blue", "C3")
text = Replace(text, "%gold", "C4")
text = Replace(text, "%gray", "C5")
text = Replace(text, "%black", "C6")
text = Replace(text, "%lgold", "C7")
text = Replace(text, "%orange", "C8")
text = Replace(text, "%yellow", "C9")
End If
If Left(text, 1) = "/" Then
Else

    AddC lblue, myname & ": ", white, text
End If

pbuffer.InsertNTString text
pbuffer.SendPacket &HE
End If
Else
AddC red, "Please connected first!"
End If
End Function

Public Function ADSplit(strdata As String) As String
On Error Resume Next
    ADSplit = Mid(strdata, 21, InStr(21, strdata, Chr(0)))
    ADSplit = Left(ADSplit, InStr(ADSplit, Chr(0)) - 1)

End Function

Public Function LinkSplit(strdata As String) As String
On Error Resume Next
    LinkSplit = Mid(strdata, 34, InStr(34, strdata, Chr(0)))
    LinkSplit = Left(LinkSplit, InStr(LinkSplit, Chr(0)) - 1)

End Function

Public Function DeHex(Data As String) As String
    Dim iCount As Double


    For iCount = 1 To Len(Data) Step 2
        DeHex = DeHex & Chr$(Val("&H" & Mid$(Data, iCount, 2)))
    Next iCount
End Function

Public Function ToHex(Data As String) As String
Dim i As Integer
For i = 1 To Len(Data)
    ToHex = ToHex & Right("00" & Hex(Asc(Mid(Data, i, 1))), 2)
Next i
End Function

    Public Function GetDWORD(Data As String) As Long
    Dim lReturn As Long
    Call CopyMemory(lReturn, ByVal Data, 4)
    GetDWORD = lReturn
    End Function
Public Function getverbyte() As Long
Select Case varProd
Case "RATS"
getverbyte = &HC5
Case "PXES"
getverbyte = &HC5
Case "PX2D"
getverbyte = &H9
Case "VD2D"
getverbyte = &H9
Case "NB2W"
getverbyte = &H4F
Case Else
MsgBox "Invalid Version", vbCritical, "Error"
End Select
End Function
Public Function D2Char(text As String)
If varProd = "PX2D" Or varProd = "VD2D" Then
If InStr(text, "*") Then
Else
text = "*" & text
Exit Function
End If
Else
text = text
Exit Function
End If
End Function
