Attribute VB_Name = "irc"
Private Type ulist
User As String
rank As Long
End Type
Private Type clist
trigger As String
action As String
End Type
Public clist() As clist
Public ulist() As ulist
Public varWM As String
Public Sub Addulist(ByVal User As String, ByVal rank As Long)
    If ulist(0).User = "" Then
        ulist(0).User = User
        ulist(0).rank = rank
    Else
        ReDim Preserve ulist(0 To UBound(ulist) + 1)
        ulist(UBound(ulist)).User = User
        ulist(UBound(ulist)).rank = rank
    End If
End Sub
Public Sub Addclist(ByVal trigger As String, ByVal action As String)
    If clist(0).trigger = "" Then
        clist(0).trigger = trigger
        clist(0).action = action
    Else
        ReDim Preserve clist(0 To UBound(clist) + 1)
        clist(UBound(clist)).trigger = trigger
        clist(UBound(clist)).action = action
    End If
End Sub
Public Function Remulist(ByVal User As String) As Boolean
Dim x As Integer, Id As Integer
Id = GetAccessIndexu(User)
If Id = -1 Then
Remulist = False
Else
For x = Id To UBound(ulist)
If x < UBound(ulist) Then
ulist(x).User = ulist(x + 1).User
ulist(x).rank = ulist(x + 1).rank
End If
Next x
If UBound(ulist) = 0 Then
Else
ReDim Preserve ulist(0 To UBound(ulist) - 1)
End If
Remulist = True
End If
End Function
Public Function Remclist(ByVal trigger As String) As Boolean
Dim x As Integer, Id As Integer
Id = GetAccessIndexc(trigger)
If Id = -1 Then
Remclist = False
Else
For x = Id To UBound(clist)
If x < UBound(clist) Then
clist(x).trigger = clist(x + 1).trigger
clist(x).action = clist(x + 1).action
End If
Next x
If UBound(clist) = 0 Then
Else
ReDim Preserve clist(0 To UBound(clist) - 1)
End If
Remclist = True
End If
End Function
Public Function GetAccessIndexc(ByVal trigger As String) As Long
On Error GoTo finishGetAccess
    Dim Id As Long
    For Id = 0 To UBound(clist)
        If LCase(clist(Id).trigger) = LCase(trigger) Then
            GetAccessIndexc = Id
            Exit Function
            End If
    Next Id
finishGetAccess:
    GetAccessIndexc = -1
End Function
Public Function GetAccessIndexu(ByVal User As String) As Long
On Error GoTo finishGetAccess
    Dim Id As Long
    For Id = 0 To UBound(ulist)
        If LCase(ulist(Id).User) = LCase(User) Then
            GetAccessIndexu = Id
            Exit Function
            End If
    Next Id
finishGetAccess:
    GetAccessIndexu = -1
End Function
Public Sub parsecommands(ByVal User As String, ByVal rank As Long, ByVal text As String, ByVal channel As String)
Dim word() As String
word() = Split(text, " ", 2)
Select Case LCase(word(0))
Case ".say"
If rank >= 5 Then
ircf.ws.SendData "PRIVMSG " & channel & " :" & word(1) & vbCrLf
End If
Case ".join"
If rank >= 5 Then
If Left(word(1), 1) = "#" Then
                    ircf.ws.SendData "JOIN " & word(1) & vbCrLf
                Else
                    ircf.ws.SendData "JOIN #" & word(1) & vbCrLf
                End If
End If
Case ".addu"
word() = Split(text, " ", 3)
If rank > word(2) Then
Addulist word(1), word(2)
Saveu "IRCu.txt"
ircf.ws.SendData "NOTICE " & User & " :" & "Added " & word(1) & " with a rank of " & word(2) & vbCrLf
End If
Case ".remu"
If GetAccessIndexu(word(1)) <> -1 Then
If rank > ulist(GetAccessIndexu(word(1))).rank Then
If Remulist(word(1)) = True Then
Saveu "IRCu.txt"
ircf.ws.SendData "NOTICE " & User & " :Removed User: " & word(1) & vbCrLf
Else
ircf.ws.SendData "NOTICE " & User & " :Failed to removed user: " & word(1) & vbCrLf
End If
Else
ircf.ws.SendData "NOTICE " & User & " :Failed to removed user: " & word(1) & vbCrLf
End If
Else
ircf.ws.SendData "NOTICE " & User & " :Failed to removed user: " & word(1) & vbCrLf
End If
Case ".addc"
Dim csplt() As String
csplt() = Split(word(1), "&", 2)
If rank >= 6 Then
Addclist csplt(0), csplt(1)
Savetc "IRCtc.txt"
ircf.ws.SendData "NOTICE " & User & " :" & "Added trigger " & csplt(0) & " with am action of " & csplt(1) & vbCrLf
End If
Case ".remc"
If rank >= 6 Then
If Remclist(word(1)) = True Then
Savetc "IRCtc.txt"
ircf.ws.SendData "NOTICE " & User & " :" & "Removed Trigger: " & word(1) & vbCrLf
Else
rcf.ws.SendData "NOTICE " & User & " :" & "Failed to removed trigger: " & word(1) & vbCrLf
End If
End If
Case ".listc"
If rank >= 6 Then
Dim z As Long
For z = 0 To UBound(clist)
ircf.ws.SendData "NOTICE " & User & " :Trigger: " & clist(z).trigger & " Action: " & clist(z).action & vbCrLf
Next
End If
Case ".listu"
If rank >= 6 Then
For z = 0 To UBound(ulist)
ircf.ws.SendData "NOTICE " & User & " :User: " & ulist(z).User & " Rank: " & ulist(z).rank & vbCrLf
Next
End If
Case ".wm"
If rank >= 8 Then
varWM = word(1)
xmlconfig.SaveSetting "IRC", "WM", varWM
End If
End Select
End Sub
Public Sub Savetc(ByVal fName As String)
    If fName = "" Then Exit Sub
    Dim sBuffer As String, i As Integer
    On Error GoTo TheEnd
    Open App.Path & "\" & fName For Output As #1
    For i = LBound(clist) To UBound(clist)
        If clist(i).trigger <> "" Then
            If i = UBound(clist) Then
                sBuffer = sBuffer & clist(i).trigger & "&" & clist(i).action
            Else
                sBuffer = sBuffer & clist(i).trigger & "&" & clist(i).action & vbCrLf
            End If
        End If
    Next i

    Print #1, sBuffer
    Close #1
TheEnd:
    Exit Sub
End Sub
Public Sub Saveu(ByVal fName As String)
    If fName = "" Then Exit Sub
    Dim sBuffer As String, i As Integer
    On Error GoTo TheEnd
    Open App.Path & "\" & fName For Output As #1
    For i = LBound(ulist) To UBound(ulist)
        If ulist(i).User <> "" Then
            If i = UBound(ulist) Then
                sBuffer = sBuffer & ulist(i).User & " " & ulist(i).rank
            Else
                sBuffer = sBuffer & ulist(i).User & " " & ulist(i).rank & vbCrLf
            End If
        End If
    Next i

    Print #1, sBuffer
    Close #1
TheEnd:
    Exit Sub
End Sub
